$regfile = "m168def.dat"
$crystal = 16000000
$framesize = 250
$hwstack = 250
$swstack = 250

Config Portc.2 = Input
Portc.2 = 1
Config Portd.0 = Output
Portd.0 = 0
Config Portd.5 = Input
Portd.5 = 1
Config Portd.6 = Input
Portd.6 = 1
Config Portd.7 = Output

Czujnik_hamulca Alias Pinc.2
Przekaznik Alias Portd.0
Funkcje Alias Pind.5
Up_tankowanie Alias Pind.6

Config Watchdog = 1024
Config Lcdpin = Pin , Db4 = Portb.2 , Db5 = Portb.3 , Db6 = Portb.4 , Db7 = Portb.5 , E = Portb.1 , Rs = Portb.0
Config Lcd = 16 * 2
Config 1wire = Portc.3
Config Sda = Portc.4
Config Scl = Portc.5
Config Int0 = Falling                                                          'zbocze opadajce
Config Int1 = Rising                                                           'zbocze narastajce

Config Adc = Single , Prescaler = Auto , Reference = Avcc
Config Timer0 = Counter , Edge = Falling
Config Timer1 = Timer , Prescale = 8
Config Timer2 = Timer , Prescale = 1024

On Int0 Spalanie_zbocze_opadajace : On Int1 Spalanie_zbocze_rosnace : On Timer2 Czas
'==========================================================Zmienne przejechanej drogi============================
Dim Przejechana_droga As Single , Suma_przejechanej_drogi As Single
Dim Przejechana_droga_odczytana As Single , Przejechana_droga_km As Single
'===============================================================Zmienna predkoci================================
Dim Predkosc As Single
'==========================================================Zmienne redniej prdkoci============================
Dim Srednia_predkosc As Single , Suma_czas_zapis As Single , Suma_czas_odczytany As Single
'==========================================================Zmienne redniego spalania============================
Dim Srednie_spalanie As Single
'============================================================Zmiennw poziomu paliwa==============================
Dim Poziom_paliwa As Word , Roznica_poziomu_paliwa As Integer , Roznica_poziomu_paliwa_sr As Long
Dim Poziom_paliwa_odczytany As Word , Srednie_pomiary_paliwa As Word , Dokonaj_obliczen As Bit
Dim Poziom_paliwa_l As Single
'=================================================Zmienne spalania chwilowego i spalania na 100km================
Dim Spalanie_l_h As Single
Dim Spalanie_l_100km As Single
Dim Suma_spalania As Long
'===============================================================Zmienna watchdoga================================
Dim Czas_watchdog As Byte
'================================================================Zmienna zasigu=================================
Dim Zasieg As Single

Dim Pik As Byte

Dim Pcf8574 As Byte

Dim Wart_bcd As Byte

Dim Srednie_pomiary As Byte
Dim Spalanie_l_h_sr As Single , Spalanie_l_h_sr_out As Single , Wyswietl_spalanie As Bit

Dim Ss1 As Byte , Mm1 As Byte , Gg1 As Byte
Dim Dni1 As Byte , Mie1 As Byte , Rok1 As Byte
'================================================================Zmienne servisu=================================
Dim Reset_servis As Bit
Dim Wymiana_oleju_bit As Bit , Wymiana_rozrzadu_bit As Bit , Wymiana_filtra_powietrza_bit As Bit
Dim Calkowita_droga_oil As Single , Calkowita_droga_roz As Single , Calkowita_droga_air As Single
Dim Calkowita_droga_odczytana_oil As Single , Calkowita_droga_odczytana_roz As Single
Dim Calkowita_droga_odczytana_air As Single
'==========================================================Zmienne do obsugi tempomatu==========================
Dim Tempomat_predkosc As Bit , Predkosc_tempomatu As Byte , Tempomat_predkosc_ustalona As Bit
Dim Predkosc_tempomatu_single As Single , Predkosc_tempomatu_byte As Byte
Dim Hamulec As Byte , Sprzeglo As Byte , Gaz As Byte
Dim Uwyj As Integer , Tempomat_flaga As Bit , Tempomat_off As Bit , Flaga_gaz As Bit
Dim Predkosc_kp As Integer , Predkosc_kd As Integer , A As Byte , B As Byte
Dim Predkosc_poprzednia As Byte , Predkosc_odchylka As Integer , Predkosc_przyrost As Integer
Dim U_pomoc_modul As Integer , U_odwrotnosc As Integer , U_pomoc As Integer
Dim Kp As Byte , Kd As Byte , Umin As Byte , Umax As Byte , Flaga As Bit
'===============================================================Zmienne pomocnicze===============================
Dim Napiecie_akumulatora As Word , Zapisz_dane_w_menu As Bit
Dim Zapisz_czas_i_date As Bit
Dim Pomoc_droga As Byte , Licz As Byte , Zezw_wysw As Bit , Pomiar_temperatury As Bit
Dim Jazda As Bit , Podprogram As Bit , Zapisz_dane As Bit , Tankowanie As Bit
Dim S As Byte , Mn As Byte , H As Byte , D As Byte , M As Byte , R As Byte
'==============================================================Zmienne czasu i daty==============================
Dim Ss As Byte , Mm As Byte , Gg As Byte , Dtyg As Byte
Dim Dni As Byte , Mie As Byte , Rok As Byte
'===============================================================Zmienne czasu jazdy==============================
Dim Sss As Byte , Mmm As Byte , Ggg As Byte
Dim Wyswietlacz As Byte , Menu As Byte
'==========================================================Zmienne temperatury zewntrznej=======================
Dim Temperatura As Integer , Temperatura_single As Single
'=======================================================Zmienne czasu zwoki wy. przekanika====================
Dim Ss_turbo As Byte , Mm_turbo As Byte , Ss_turbo_czas As Byte , Mm_turbo_czas As Byte

Dim Pomoc_1 As Word
'==================================================Zmienne czasu do obliczenia redniej prdkoci================
Dim Czas As Word , Suma_czas_zapis_czas As Single
'============================================================Zmienne kodu dostepu================================
Dim Code_1 As Byte , Code_2 As Byte , Code_3 As Byte , Code_4 As Byte , Code_wybor As Byte
Dim Code_1_in As Byte , Code_2_in As Byte , Code_3_in As Byte , Code_4_in As Byte , Dane As Byte
Dim Kod As Bit
'======================================================================Stae=====================================
Const Czas_ = "Ustawianie czasu"
Const Data_ = "Ustawianie daty"
Const L_100km = "l/100km"
Const _km = "km"
Const Km_h = "km/h"
Const Wymiana_oleju = "Wymiana oleju"
Const Wymiana_rozrzadu = "Wymiana rozrzadu"
Const Wymiana_filtra_powietrza = "Filtr powietrza"
Const Tempomat_ = "Tempomat"
Const Stala_paliwa = 0.082
Const Oil_ = 10000
Const Air_ = 35000
Const Roz_ = 60000
'================================================================Deklaracje procedur=============================
Declare Sub Zapisz_czas_i_date
Declare Sub Odczytaj_czas_i_date
Declare Sub Pomiar_napiecia
Declare Sub Pomiar_paliwa
Declare Sub Czekaj_10s
Declare Sub Czekaj_2s
Declare Sub Locate_1_1
Declare Sub Locate_2_3
Declare Sub Locate_2_5
Declare Sub Locate_2_17
Declare Sub Czas_lcd
Declare Sub Data_lcd
Declare Sub Buzzer
Declare Sub Buzer_3pikniecia
Declare Sub Zapisz_oil
Declare Sub Zapisz_roz
Declare Sub Zapisz_air
Declare Sub Tempomat_obsluga
Declare Sub Pcf8574_panel
Declare Sub Tempomat_off
Declare Sub Zapisz_dane_funkcja
Declare Sub Odczyt_kodu
Declare Sub Code
Declare Sub Aktualny_kod
Declare Sub Nowy_kod
Declare Sub Odczyt_danych
Declare Sub Zadanie_kodu
Declare Sub Czas_nastaw
Declare Sub Data_nastaw

'Code_1 = 1
'Code_2 = 1
'Code_3 = 1
'Code_4 = 1
'Writeeeprom Code_1 , 29
'Writeeeprom Code_2 , 30
'Writeeeprom Code_3 , 31
'Writeeeprom Code_4 , 32
'Calkowita_droga_oil = 4000
'Calkowita_droga_roz = 5984
'Calkowita_droga_air = 25000
'Writeeeprom Calkowita_droga_oil , 13
'Writeeeprom Calkowita_droga_roz , 17
'Writeeeprom Calkowita_droga_air , 21
'Srednie_spalanie = 7.3
'Writeeeprom Srednie_spalanie , 36

Enable Interrupts : Enable Int0 : Enable Int1 : Start Adc : Enable Timer2

Cursor Off

Do                                                                             'gwna ptla programu
  If Funkcje = 0 Then
     Call Buzzer
     Call Czekaj_2s
     If Funkcje = 0 Then
        Podprogram = 1
     Else
        Podprogram = 0
     End If
  End If

  If Podprogram = 1 Then
     Readeeprom Dane , 35
     Cls
     Locate 1 , 7
     Lcd "MENU"
     Call Buzer_3pikniecia
     Call Czekaj_10s
     Start Watchdog
     Call Odczyt_kodu
     Call Odczytaj_czas_i_date
          Ss1 = Makedec(ss)                                                    'odczytane dane w kodzie BCD nalerzy zdekodowa
          Mm1 = Makedec(mm)                                                    'na posta dziesietn
          Gg1 = Makedec(gg)
          Dni1 = Makedec(dni)
          Mie1 = Makedec(mie)
          Rok1 = Makedec(rok)
     Cursor Blink
     If Dane.0 = 1 Then                                                        'gdy danie kodu wczone
        Do
          Call Zadanie_kodu
        Loop Until Code_wybor > 4
        Code_wybor = 0
     End If
  Do
    If Zezw_wysw = 1 Then
       Czas_watchdog = 0
       Call Odczyt_danych
       Readeeprom Dane , 35

       If Funkcje = 0 Then
          Waitms 200
          If Funkcje = 0 Then
             Call Buzzer
             Incr Menu
          End If
       End If

       Cls
       Select Case Menu
         Case 0:
          Call Locate_1_1
           Lcd Czas_;
          Call Czas_nastaw
          Locate 2 , 5

           If Up_tankowanie = 0 Then
              Gg1 = Gg1 + 1
              Call Buzzer
              If Gg1 = 24 Then Gg1 = 0
              Set Zapisz_czas_i_date
           End If

         Case 1:
          Call Locate_1_1
           Lcd Czas_ ;
          Call Czas_nastaw
          Locate 2 , 8

           If Up_tankowanie = 0 Then
              Mm1 = Mm1 + 1
              Call Buzzer
              If Mm1 = 60 Then Mm1 = 0
              Set Zapisz_czas_i_date
           End If

         Case 2:
          Call Locate_1_1
           Lcd Czas_ ;
          Call Czas_nastaw
          Locate 2 , 11

           If Up_tankowanie = 0 Then
              Ss1 = Ss1 + 1
              Call Buzzer
              If Ss1 = 60 Then Ss1 = 0
              Set Zapisz_czas_i_date
           End If

         Case 3:
          Call Locate_1_1
           Lcd Data_ ;
          Call Data_nastaw
          Locate 2 , 5

           If Up_tankowanie = 0 Then
              Dni1 = Dni1 + 1
              Call Buzzer
              If Dni1 = 32 Then Dni1 = 1
              Set Zapisz_czas_i_date
           End If

         Case 4:
          Call Locate_1_1
           Lcd Data_ ;
          Call Data_nastaw
          Locate 2 , 8

           If Up_tankowanie = 0 Then
              Mie1 = Mie1 + 1
              Call Buzzer
              If Mie1 = 13 Then Mie1 = 1
              Set Zapisz_czas_i_date
           End If

         Case 5:
          Call Locate_1_1
           Lcd Data_ ;
          Call Data_nastaw
          Locate 2 , 11

           If Up_tankowanie = 0 Then
              Rok1 = Rok1 + 1
              Call Buzzer
              If Rok1 = 100 Then Rok1 = 0
              Set Zapisz_czas_i_date
           End If

         Case 6:
          Locate 1 , 3
           Lcd "Kd tempomatu"
          Call Locate_2_3
           Lcd "Kd=" ; Kd
          Call Locate_2_17

           If Up_tankowanie = 0 Then
              Incr Kd
              Call Buzzer
              If Kd = 10 Then Kd = 0
              Set Zapisz_dane_w_menu
           End If

         Case 7:
          Locate 1 , 3
           Lcd "Kp tempomatu"
          Call Locate_2_3
           Lcd "Kp=" ; Kp
          Call Locate_2_17

           If Up_tankowanie = 0 Then
              Incr Kp
              Call Buzzer
              If Kp = 5 Then Kp = 0
              Set Zapisz_dane_w_menu
           End If

         Case 8:
          Call Locate_1_1
           Lcd "Poprzedni pomiar"
          Call Locate_2_3
           Lcd "Pomiar=" ; B
          Call Locate_2_17

           If Up_tankowanie = 0 Then
              Incr B
              Call Buzzer
              If B = 10 Then B = 0
              Set Zapisz_dane_w_menu
           End If

         Case 9:
          Call Locate_1_1
           Lcd "Umin.pedalu gazu"
          Call Locate_2_3
           Lcd "Umin=" ; Umin
          Call Locate_2_17

           If Up_tankowanie = 0 Then
              Incr Umin
              Call Buzzer
              If Umin < 80 Then Umin = 95
              If Umin > 95 Then Umin = 80
              Set Zapisz_dane_w_menu
           End If

         Case 10:
          Call Locate_1_1
           Lcd "Umax.pedalu gazu"
          Call Locate_2_3
           Lcd "Umax=" ; Umax
          Call Locate_2_17

           If Up_tankowanie = 0 Then
              Incr Umax
              Call Buzzer
              If Umax < 180 Then Umax = 220
              If Umax > 220 Then Umax = 180
              Set Zapisz_dane_w_menu
           End If

         Case 11:
          Call Locate_1_1
           Lcd " Rzadanie kodu"
          Call Locate_2_3
           If Dane.0 = 0 Then
              Lcd "Wylaczone"
           Else
              Lcd "Wlaczone"
           End If
          Call Locate_2_17

           If Up_tankowanie = 0 Then
              Toggle Dane.0
              Call Buzzer
              Set Zapisz_dane_w_menu
           End If

         Case 12:
          If Dane.0 = 0 Then
             Menu = 13
          Else
             Call Locate_1_1
              Lcd "Zm. kod dostepu"
             Call Locate_2_17
              Call Czekaj_2s

              Do
                If Zezw_wysw = 1 Then
                 If Funkcje = 0 Then
                    Incr Code_wybor
                    Call Buzzer
                 End If
                 Cls

                   Select Case Code_wybor
                    Case 0:
                      Call Nowy_kod
                      Call Code
                     Locate 2 , 7

                     If Up_tankowanie = 0 Then
                        Incr Code_1
                        Call Buzzer
                        If Code_1 > 9 Then Code_1 = 0
                        Writeeeprom Code_1 , 29
                     End If

                    Case 1:
                      Call Nowy_kod
                      Call Code
                     Locate 2 , 8

                     If Up_tankowanie = 0 Then
                        Incr Code_2
                        Call Buzzer
                        If Code_2 > 9 Then Code_2 = 0
                        Writeeeprom Code_2 , 30
                     End If

                    Case 2:
                      Call Nowy_kod
                      Call Code
                     Locate 2 , 9

                     If Up_tankowanie = 0 Then
                        Incr Code_3
                        Call Buzzer
                        If Code_3 > 9 Then Code_3 = 0
                        Writeeeprom Code_3 , 31
                     End If

                    Case 3:
                      Call Nowy_kod
                      Call Code
                     Locate 2 , 10

                     If Up_tankowanie = 0 Then
                        Incr Code_4
                        Call Buzzer
                        If Code_4 > 9 Then Code_4 = 0
                        Writeeeprom Code_4 , 32
                     End If

                   End Select
                Reset Zezw_wysw
                End If
              Loop Until Code_wybor > 3
           Menu = 13
          End If
       End Select
       If Zapisz_dane_w_menu = 1 Then
          Writeeeprom Kd , 26
          Writeeeprom Kp , 27
          Writeeeprom B , 28
          Writeeeprom Umin , 33
          Writeeeprom Umax , 34
          Writeeeprom Dane , 35
          Reset Zapisz_dane_w_menu
       End If
       Reset Zezw_wysw
    End If
  Loop Until Menu > 12
  Reset Podprogram

       If Zapisz_czas_i_date = 1 Then
          Call Zapisz_czas_i_date
          Reset Zapisz_czas_i_date
       End If

  Else

    Cursor Noblink
    Cursor Off
    Readeeprom Wyswietlacz , 25
    Readeeprom Dane , 35
    Readeeprom Srednie_spalanie , 36

    Call Buzzer

    Cls
    Lcd ; Spc(3) ; "Ford focus"
    Lowerline
    Lcd ; Spc(2) ; "1,8TDDI 90PS"
    Call Czekaj_2s
    Set Przekaznik                                                             'wcz przekanik

    Pcf8574.4 = 0                                                              'kontrola dziaania lampek kontrolnych
    Pcf8574.1 = 0                                                              'zapal lampki
    Pcf8574.2 = 0
    Pcf8574.5 = 0
    Call Pcf8574_panel

    Call Czekaj_2s
    Call Czekaj_2s

    Pcf8574.4 = 1                                                              'zga lampki kontrolne
    Pcf8574.1 = 1
    Pcf8574.2 = 1
    Pcf8574.5 = 1
    Call Pcf8574_panel

    Readeeprom Calkowita_droga_oil , 13
    Readeeprom Calkowita_droga_air , 21
    Readeeprom Calkowita_droga_roz , 17
    Readeeprom Zasieg , 40
    Calkowita_droga_oil = Oil_ - Calkowita_droga_oil
    Calkowita_droga_air = Air_ - Calkowita_droga_air
    Calkowita_droga_roz = Roz_ - Calkowita_droga_roz

    Call Buzzer
    Cls
     Lcd "Wymiana oleju za"
      Lowerline
     Lcd "Oil=" ; Fusing(calkowita_droga_oil , "#####.#") ; _km
    Call Czekaj_2s
    Call Buzzer
    Cls
     Lcd "Flitr powietrza"
      Lowerline
     Lcd "Air=" ; Fusing(calkowita_droga_air , "#####.#") ; _km
    Call Czekaj_2s
    Call Buzzer
    Cls
     Lcd "Wymiana rozrzadu"
      Lowerline
     Lcd "Roz=" ; Fusing(calkowita_droga_roz , "#####.#") ; _km
    Call Czekaj_2s
    Call Buzzer
    Pcf8574.1 = Dane.1                                                         'przepisz poprzednie konfiguracje lampek kontrolnych
    Pcf8574.2 = Dane.2
    Pcf8574.3 = Dane.3
    Pcf8574.5 = Dane.5
    Start Watchdog

  Do
    If Zezw_wysw = 1 Then
       Cls
       If Funkcje = 0 Then
          Waitms 25
          If Funkcje = 0 Then
             Call Buzzer
             Incr Wyswietlacz
          End If
       End If

       If Wyswietlacz > 7 Then Wyswietlacz = 0

       If Wymiana_oleju_bit = 1 Or Wymiana_rozrzadu_bit = 1 Or Wymiana_filtra_powietrza_bit = 1 Then
         Call Buzzer
         If Wymiana_oleju_bit = 1 Then
           Locate 1 , 2
            Lcd ; Wymiana_oleju ;
         End If
         If Wymiana_rozrzadu_bit = 1 Then
           Locate 2 , 1
            Lcd ; Wymiana_rozrzadu ;
         End If
         If Wymiana_filtra_powietrza_bit = 1 Then
           Locate 2 , 1
            Lcd ; Wymiana_filtra_powietrza ;
         End If

         If Up_tankowanie = 0 Then
           Call Buzzer
           Waitms 500
           If Up_tankowanie = 0 Then
             Set Reset_servis
             Do
               If Wymiana_oleju_bit = 1 Then : Reset Wymiana_oleju_bit : Calkowita_droga_oil = 0 : Call Zapisz_oil : End If
               If Wymiana_rozrzadu_bit = 1 Then : Reset Wymiana_rozrzadu_bit : Calkowita_droga_roz = 0 : Call Zapisz_roz : End If
               If Wymiana_filtra_powietrza_bit = 1 Then : Reset Wymiana_filtra_powietrza_bit : Calkowita_droga_air = 0 : Call Zapisz_air : End If
               Cls
               Locate 1 , 3
               Lcd "Reset servis"
               Pik = 0
               Call Buzer_3pikniecia
               Call Czekaj_10s
               Reset Reset_servis
             Loop Until Reset_servis = 0
           End If
         End If

       Else

       If Up_tankowanie = 0 Then
          Call Buzzer
          If Tempomat_predkosc_ustalona = 1 Then
             Reset Tempomat_predkosc_ustalona
             Set Tempomat_off
          Else
             Set Tempomat_flaga
          End If
          Call Czekaj_2s
          If Up_tankowanie = 0 Then
             Set Tankowanie
             Reset Tempomat_flaga
             If Tankowanie = 1 Then
                Do
                  Cls
                     Locate 1 , 4
                     Lcd "Tankowanie"
                     Call Czekaj_10s
                     Call Czekaj_10s
                     Call Czekaj_10s
                     Call Czekaj_10s
                     Call Pomiar_paliwa
                     Suma_przejechanej_drogi = 0
                     Suma_czas_zapis = 0
                     Writeeeprom Poziom_paliwa , 9
                     Writeeeprom Suma_przejechanej_drogi , 1
                     Writeeeprom Suma_czas_zapis , 5
                     Poziom_paliwa_l = Poziom_paliwa * Stala_paliwa
                  Cls
                     Lcd "Tankowanie=" ; Fusing(poziom_paliwa_l , "##.#") ; "L"
                     Pik = 0
                     Call Buzer_3pikniecia
                     Call Czekaj_2s
                     Reset Tankowanie
                     Reset Tempomat_flaga
                Loop Until Tankowanie = 0
             End If
          End If
       Else
          If Tempomat_flaga = 1 Then
             Do
               Cls
                  Locate 1 , 4
                  Lcd ; Tempomat_;
                  Locate 2 , 5
                  Lcd "aktywny"
                  Pik = 0
                  Call Buzer_3pikniecia
                  Predkosc_tempomatu = Pomoc_droga
                  Predkosc_tempomatu_single = 0
                  Predkosc_tempomatu_single = Predkosc
                  Call Czekaj_2s
               Cls
                  Locate 1 , 1
                  Lcd "Predkosc zadana"
                  Locate 2 , 3
                  Predkosc_tempomatu_byte = Int(predkosc_tempomatu_single)
                  Lcd "V=" ; Predkosc_tempomatu_byte ; Km_h;
               Set Tempomat_predkosc_ustalona
                  Call Czekaj_2s
               Reset Tempomat_flaga
             Loop Until Tempomat_flaga = 0
          End If
          If Tempomat_off = 1 Then
             Do
               Cls
                  Locate 1 , 4
                  Lcd ; Tempomat_;
                  Locate 2 , 3
                  Lcd "nie aktywny"
                  Pik = 0
                  Uwyj = 0
                  Call Tempomat_obsluga
                  Call Buzer_3pikniecia
                  Call Czekaj_2s
               Reset Tempomat_off
             Loop Until Tempomat_off = 0
          End If
       End If

       Select Case Wyswietlacz
         Case 0:                                                               'godzina i data
          Locate 1 , 5
           Call Czas_lcd
           Call Locate_2_5
           Call Data_lcd

         Case 1:                                                               'temperatura zewntrzna
          Call Locate_1_1
           Lcd "Temperatura zew."
          Call Locate_2_3
           Lcd "Tzew=" ; Fusing(temperatura_single , "##.#") ; "oC"

         Case 2:                                                               'droga ktr mona przejecha , droga przejachana ,spalanie chwilowe
          Call Locate_1_1
           Lcd "Trasa=" ; Fusing(przejechana_droga_km , "###.#") ; _km ;
          Locate 2 , 1
           Lcd "Droga=" ; Fusing(suma_przejechanej_drogi , "###.#") ; _km ;

         Case 3:
          Locate 1 , 2
           Lcd "Spalanie chw."
           If Jazda = 1 Then
              Locate 2 , 6
               Lcd Fusing(spalanie_l_100km , "##.#") ; L_100km ;
           Else
              Locate 2 , 6
               Lcd Fusing(spalanie_l_h_sr_out , "##.#") ; "L/h"
           End If

         Case 4:                                                               'predkosc chwilowa i czas jazdy
          Locate 1 , 5
           Lcd Fusing(predkosc , "###.#") ; Km_h;
          Locate 2 , 5
           Wart_bcd = Makebcd(ggg)
           Lcd Bcd(wart_bcd) ; ":"
           Wart_bcd = Makebcd(mmm)
           Lcd Bcd(wart_bcd) ; ":"
           Wart_bcd = Makebcd(sss)
           Lcd Bcd(wart_bcd);

         Case 5:
          Call Locate_1_1                                                      'srednie spalanie
           Lcd "Srednie spalanie"
          Locate 2 , 5
           Lcd Fusing(srednie_spalanie , "##.#") ; L_100km ;

         Case 6:
          Call Locate_1_1
           Lcd "Srednia predkosc"
          Locate 2 , 5
           Lcd Fusing(srednia_predkosc , "##.#") ; Km_h;

         Case 7:
          Locate 1 , 6
           Lcd "Zasieg"
          Locate 2 , 4
           Lcd Fusing(zasieg , "####.#") ; _km ;

       End Select
       End If

       1wreset
       If Pomiar_temperatury = 0 Then
          1wwrite &HCC
          1wwrite &H44
       Else
          1wwrite &HCC
          1wwrite &HBE
          Temperatura = 1wread(2)
          Temperatura = Temperatura Or 65536
        If Jazda = 1 Then
          Temperatura_single = Temperatura * 0.5
        End If
       End If
       If Pomoc_droga <> 0 Then
          Jazda = 1
       Else
          Jazda = 0
       End If

       Readeeprom Przejechana_droga_odczytana , 1
       Readeeprom Suma_czas_odczytany , 5
       Readeeprom Poziom_paliwa_odczytany , 9
       Readeeprom Calkowita_droga_odczytana_oil , 13
       Readeeprom Calkowita_droga_odczytana_roz , 17
       Readeeprom Calkowita_droga_odczytana_air , 21
       Call Odczyt_danych

       If Tempomat_predkosc_ustalona = 1 Then                                  'gdy tempomat jest aktywny zapal lampk
          Set Flaga                                                            'ustawiaj flage
          Call Tempomat_off                                                    'sprawdz peday
          If Flaga = 1 Then                                                    'obliczenia tylko gdy sprzgo i hamulec s puszczone
             If Flaga_gaz = 0 Then
                Pcf8574.4 = 0                                                  'lampaka zapalona
             Else
                Toggle Pcf8574.4
             End If
             Incr A
             If A > B Then : A = 0 : Predkosc_poprzednia = Pomoc_droga : End If
             Predkosc_odchylka = Predkosc_tempomatu - Pomoc_droga
             Predkosc_przyrost = Predkosc_poprzednia - Pomoc_droga
             Predkosc_kp = Predkosc_odchylka * Kp
             Predkosc_kd = Predkosc_przyrost * Kd
             U_pomoc = Predkosc_kp + Predkosc_kd
             U_odwrotnosc = 255 - U_pomoc
             U_pomoc_modul = Abs(uwyj)

             If U_pomoc < 0 Then
                If U_pomoc_modul > Uwyj Then
                   Uwyj = 0
                Else
                   Uwyj = Uwyj + U_pomoc
                End If
             Else
                If U_pomoc_modul > U_odwrotnosc Then
                   Uwyj = 255
                Else
                   Uwyj = Uwyj + U_pomoc
                End If
             End If
             If Flaga_gaz = 0 Then                                             'gdy gaz puszczony                                           'gdy peda gazu wcinity
                If Uwyj > Umax Then Uwyj = Umax
                If Uwyj < Umin Then Uwyj = Umin
             Else
                Uwyj = 0                                                       'gdy gaz wcisnity
             End If
          Else
             Predkosc_odchylka = 0                                             'gdy sprzgo albo hamulec wcisnity
             Predkosc_przyrost = 0
             Uwyj = 0
             Toggle Pcf8574.4                                                  'lampka miga bo wcisnity jest hamulec albo sprzego
          End If
       Else
          Pcf8574.4 = 1                                                        'gdy tempomat jest nieaktywny zga lampk
          Predkosc_odchylka = 0
          Predkosc_przyrost = 0
          Uwyj = 0                                                             'lampka zgaszona
       End If

       Call Tempomat_obsluga
       Call Odczytaj_czas_i_date
       Call Pomiar_paliwa                                                      'pomiar poziomu paliwa
       Call Pcf8574_panel

       Napiecie_akumulatora = Getadc(1)                                        'pomiar napicia akumulatora

       Przejechana_droga_km = Przejechana_droga / 5066.4
       Suma_przejechanej_drogi = Przejechana_droga_odczytana + Przejechana_droga_km

       Calkowita_droga_oil = Calkowita_droga_odczytana_oil + Przejechana_droga_km
       Calkowita_droga_roz = Calkowita_droga_odczytana_roz + Przejechana_droga_km
       Calkowita_droga_air = Calkowita_droga_odczytana_air + Przejechana_droga_km

       If Calkowita_droga_oil > Oil_ Then Set Wymiana_oleju_bit
       If Calkowita_droga_roz > Roz_ Then Set Wymiana_rozrzadu_bit
       If Calkowita_droga_air > Air_ Then Set Wymiana_filtra_powietrza_bit

       Predkosc = Pomoc_droga * 1.472

       Suma_czas_zapis_czas = Suma_czas_zapis_czas + Czas
       Suma_czas_zapis_czas = Suma_czas_zapis_czas / 3600
       Suma_czas_zapis = Suma_czas_odczytany + Suma_czas_zapis_czas
       Srednia_predkosc = Suma_przejechanej_drogi / Suma_czas_zapis

       If Mmm <> 0 Then                                                        'przelicz po ustabilizowaniu wartoci paliwa
          Incr Srednie_pomiary_paliwa                                          'zwiksz zawarto
          Roznica_poziomu_paliwa = Poziom_paliwa_odczytany - Poziom_paliwa     'obliczenia rnicy poziomu paliwa
          Roznica_poziomu_paliwa_sr = Roznica_poziomu_paliwa_sr + Roznica_poziomu_paliwa
          Zasieg = Poziom_paliwa / Srednie_spalanie                            'obloczenia zasigu
          Zasieg = Zasieg * 10                                                 'przeliczenie zasigu na km
       End If

       If Srednie_pomiary_paliwa > 1200 Then : Srednie_pomiary_paliwa = 0 : Set Dokonaj_obliczen : End If

       If Dokonaj_obliczen = 1 Then
          If Suma_przejechanej_drogi > 100 Then                                'dokonaj oblicze gdy jest przejechane wjcej ni 100km
             Srednie_spalanie = Roznica_poziomu_paliwa_sr / Suma_przejechanej_drogi
             Srednie_spalanie = Srednie_spalanie * 0.00677                     'przeliczenie na litry
              If Srednie_spalanie < 0 Then Srednie_spalanie = 0
              Roznica_poziomu_paliwa_sr = 0                                    'kasuj zawarto zmiennej
              Reset Dokonaj_obliczen                                           'kasuj flage
          End If
       End If

       Spalanie_l_h = Suma_spalania / 112200
       Spalanie_l_h = Spalanie_l_h - 1
       Spalanie_l_h = Spalanie_l_h * 10
       Spalanie_l_h_sr = Spalanie_l_h_sr + Spalanie_l_h

       Incr Srednie_pomiary
       If Srednie_pomiary > 5 Then : Srednie_pomiary = 0 : Set Wyswietl_spalanie : End If

       If Wyswietl_spalanie = 1 Then
          Spalanie_l_h_sr_out = Spalanie_l_h_sr / 5
           If Spalanie_l_h_sr_out < 0 Then Spalanie_l_h_sr_out = 0
          Spalanie_l_h_sr = 0
          Reset Wyswietl_spalanie
       End If

       Spalanie_l_100km = Spalanie_l_h_sr_out / Pomoc_droga
       Spalanie_l_100km = Spalanie_l_100km * 68

       If Mmm <> 0 Then                                                        'poczekaj na stabilizacj zawartoci zmiennych
          If Zasieg < 50 Then Pcf8574.1 = 0                                    'gdy zasig jest mniejszy ni 50km zapal lampk
          If Zasieg > 60 Then Pcf8574.1 = 1                                    'gdy zasig jest wikszy niz 100km zga lampk
          If Temperatura_single < 2 Then Pcf8574.2 = 0                         'gdy jast gooledz zapal lampk
          If Temperatura_single > 2 Then Pcf8574.2 = 1
          If Temperatura_single > 4 Then Pcf8574.2 = 1                         'gdy nie ma gooledzi zga lampk
          If Temperatura_single < 0 Then : Pcf8574.3 = 0 : Pcf8574.2 = 1 : End If       'gdy jest oblodzona droga zapal lampk
          If Temperatura_single > 1 Then Pcf8574.3 = 1                         'gdy nie ma oblodzenia drogi zga lampk
          If Napiecie_akumulatora < 563 Then Pcf8574.5 = 0                     'gdy napicie akumulatora spadnie poniej 11V zapal lampk
          If Napiecie_akumulatora > 640 Then Pcf8574.5 = 1                     'gdy napicie wzronie powyrzej 12,5V zga lampk
       End If

       If Napiecie_akumulatora > 500 Then                                      'gdy kluczyk wczony
        Set Zapisz_dane                                                        'ustaw flag zapizu danych
        Set Przekaznik
        Czas_watchdog = 0
        If Czujnik_hamulca = 0 Then                                            'hamulec reczny zacigniety
           Ss_turbo = 0
           Mm_turbo = 0
           Ss_turbo = Mmm
           Mm_turbo = Ggg
           If Mmm = 0 Then
              Ss_turbo = 10
              Ss_turbo_czas = 0
              Mm_turbo_czas = 0
           Else
              If Ss_turbo < 30 Then Ss_turbo = 30
              If Mm_turbo > 2 Then Mm_turbo = 2
              Ss_turbo_czas = 0
              Mm_turbo_czas = 0
           End If
        End If
       Else                                                                    'gdy kluczyk wyczony
        If Pomiar_temperatury = 1 Then                                         'licz czas do wyczenia silnika
           Incr Ss_turbo_czas
           If Ss_turbo_czas = 60 Then
              Ss_turbo_czas = 0
              Incr Mm_turbo_czas
           End If
        End If
        Call Zapisz_dane_funkcja
        If Czujnik_hamulca = 1 Then                                            'hamulec nie rczny zacignity
           If Mm_turbo <> Mm_turbo_czas And Ss_turbo <> Ss_turbo_czas Then : Czas_watchdog = 0 : Else : Czas_watchdog = 121 : End If
        End If
       End If
    Reset Zezw_wysw
    Suma_spalania = 0
    End If
  Loop
  End If
Loop                                                                           'koniec gwnej petli programu
Stop                                                                           'koniec programu ale nie wyczaj przerwa

Czas:
  Timer2 = Timer2 + 39
  Incr Licz
  If Licz = 36 Then
     Licz = 0
     Pomoc_droga = Timer0
     Timer0 = 0
     Set Zezw_wysw
     Przejechana_droga = Przejechana_droga + Pomoc_droga
     Toggle Pomiar_temperatury
      'If Napiecie_akumulatora > 500 Then                                       'watchdog ma czuwa tylko wtedy gdy kluczyk jest przekrcony
         Incr Czas_watchdog
         If Czas_watchdog < 120 Then Reset Watchdog
      'End If
      If Pomiar_temperatury = 1 Then
        Incr Sss
        Incr Czas
        If Sss = 60 Then
           Sss = 0
           Incr Mmm
           If Mmm = 60 Then
              Mmm = 0
              Incr Ggg
              If Ggg = 24 Then
                 Ggg = 0
              End If
           End If
        End If
      End If
  End If
Return

Spalanie_zbocze_opadajace:
  Pomoc_1 = 0
  Timer1 = 0
  Start Timer1
Return

Spalanie_zbocze_rosnace:
  Stop Timer1
  Pomoc_1 = Timer1
  Suma_spalania = Suma_spalania + Pomoc_1
Return

Sub Pomiar_paliwa:
  Poziom_paliwa = Getadc(0)
  Poziom_paliwa = Poziom_paliwa - 112
End Sub

Sub Czekaj_2s:
  Wait 2
End Sub

Sub Czekaj_10s:
  Wait 10
End Sub

Sub Locate_1_1:
  Locate 1 , 1
End Sub

Sub Locate_2_3:
  Locate 2 , 3
End Sub

Sub Locate_2_5:
  Locate 2 , 5
End Sub

Sub Zapisz_oil:
  Writeeeprom Calkowita_droga_oil , 13
End Sub

Sub Zapisz_roz:
  Writeeeprom Calkowita_droga_roz , 17
End Sub

Sub Zapisz_air:
  Writeeeprom Calkowita_droga_air , 21
End Sub

Sub Czas_lcd:
  Lcd Bcd(gg) ; ":" ; Bcd(mm) ; ":" ; Bcd(ss);
End Sub

Sub Data_lcd:
  Lcd Bcd(dni) ; "-" ; Bcd(mie) ; "-" ; Bcd(rok);
End Sub

Sub Buzzer:
  Sound Pind.7 , 300 , 150
End Sub

Sub Buzer_3pikniecia:
  Do
    Incr Pik
    Sound Pind.7 , 300 , 150
    Waitms 400
  Loop Until Pik > 3
End Sub

Sub Tempomat_obsluga:
    I2cstart                                                                   'start magistrali i2c
     I2cwbyte 144                                                              'adres nadawczy
     I2cwbyte &B01001100                                                       'umoliwia prac A/D
     I2cwbyte 64                                                               'umoliwia prac D/A
     I2cwbyte Uwyj
    I2cstart                                                                   'sygna startu
     I2cwbyte 145                                                              'adres odbiorczy
     I2crbyte Gaz , Ack
     I2crbyte Sprzeglo , Ack
     I2crbyte Hamulec , Nack
    I2cstop                                                                    'sygna stop magistrali i2c
End Sub

Sub Tempomat_off:
    If Tempomat_predkosc_ustalona = 1 Then
       If Hamulec > 170 And Sprzeglo > 170 Then : Reset Tempomat_predkosc_ustalona : Set Tempomat_off : End If
       If Hamulec > 170 Then Reset Flaga                                       'gdy hamulec wcisniety
       If Sprzeglo > 170 Then Reset Flaga                                      'gdy sprzgo wcinite
       If Gaz < 100 Then Set Flaga_gaz
       If Gaz > 190 Then Reset Flaga_gaz
    End If
End Sub

Sub Pcf8574_panel:
   I2csend &H40 , Pcf8574                                                      'wysanie danych do ukadu PCF8574
End Sub

Sub Odczytaj_czas_i_date:
   I2cstart
   I2cwbyte 162
   I2cwbyte 2
   I2cstart
   I2cwbyte 163
   I2crbyte Ss , Ack                                                           'odczytane dane w kodzie BCD
   I2crbyte Mm , Ack
   I2crbyte Gg , Ack
   I2crbyte Dni , Ack
   I2crbyte Dtyg , Ack
   I2crbyte Mie , Ack
   I2crbyte Rok , Nack
   I2cstop

   Ss = Ss And &B01111111                                                      'maskowanie
   Mm = Mm And &B01111111
   Gg = Gg And &B00111111
   Dni = Dni And &B00111111
   Mie = Mie And &B00011111
End Sub

Sub Zapisz_czas_i_date:
   'S = Makebcd(ss1)
   'Mn = Makebcd(mm1)
   'H = Makebcd(gg1)
   'D = Makebcd(dni1)
   'M = Makebcd(mie1)
   'R = Makebcd(rok1)
   Dtyg = Makebcd(1)

  I2cstart
  I2cwbyte 162
  I2cwbyte 0
  I2cwbyte 8
  I2cstop
  I2cstart
  I2cwbyte 162
  I2cwbyte 2
  I2cwbyte S                                                                   'zapis zmiennych w kodzie BCD
  I2cwbyte Mn
  I2cwbyte H
  I2cwbyte D
  I2cwbyte Dtyg
  I2cwbyte M
  I2cwbyte R
  I2cstop
End Sub

Sub Zapisz_dane_funkcja:
  If Zapisz_dane = 1 Then
     Pik = 0
     Call Buzer_3pikniecia
     Writeeeprom Suma_przejechanej_drogi , 1
     Writeeeprom Suma_czas_zapis , 5
     Call Zapisz_oil
     Call Zapisz_roz
     Call Zapisz_air
     Writeeeprom Wyswietlacz , 25
     Dane.1 = Pcf8574.1                                                        'przepisz zawarto
     Dane.2 = Pcf8574.2
     Dane.3 = Pcf8574.3
     Dane.5 = Pcf8574.5
     Writeeeprom Dane , 35                                                     'zapisz zawartoc
     Writeeeprom Srednie_spalanie , 36
     Writeeeprom Zasieg , 40
     Przejechana_droga = 0
     Suma_czas_zapis_czas = 0
     Reset Zapisz_dane
  End If
End Sub

Sub Odczyt_kodu:
  Readeeprom Code_1_in , 29
  Readeeprom Code_2_in , 30
  Readeeprom Code_3_in , 31
  Readeeprom Code_4_in , 32
End Sub

Sub Odczyt_danych:
  Readeeprom Kd , 26
  Readeeprom Kp , 27
  Readeeprom B , 28
  Readeeprom Umin , 33
  Readeeprom Umax , 34
End Sub

Sub Code:
  Locate 2 , 7
   Lcd ; Code_1 ; ; Code_2 ; ; Code_3 ; ; Code_4;
End Sub

Sub Aktualny_kod:
  Locate 1 , 3
   Lcd "Aktualny kod"
End Sub

Sub Nowy_kod:
  Locate 1 , 5
   Lcd "Nowy kod"
End Sub

Sub Czas_nastaw:
  Call Locate_2_5
   H = Makebcd(gg1)
   Lcd Bcd(h) ; ":";
  Locate 2 , 8
   Mn = Makebcd(mm1)
   Lcd Bcd(mn) ; ":";
  Locate 2 , 11
   S = Makebcd(ss1)
   Lcd Bcd(s);
End Sub

Sub Data_nastaw:
  Call Locate_2_5
   D = Makebcd(dni1)
   Lcd Bcd(d) ; "-";
  Locate 2 , 8
   M = Makebcd(mie1)
   Lcd Bcd(m) ; "-";
  Locate 2 , 11
   R = Makebcd(rok1)
   Lcd Bcd(r);
End Sub

Sub Zadanie_kodu:
    If Zezw_wysw = 1 Then
       If Funkcje = 0 Then
          Waitms 200
          If Funkcje = 0 Then
             Call Buzzer
             Incr Code_wybor
             If Code_wybor < 5 Then
                If Code_wybor > 4 Then Code_wybor = 4
             End If
          End If
       End If
       Cls
       Select Case Code_wybor
         Case 0:
           Call Aktualny_kod
           Call Code
          Locate 2 , 7

          If Up_tankowanie = 0 Then
             Incr Code_1
             Call Buzzer
             If Code_1 > 9 Then Code_1 = 0
          End If

         Case 1:
           Call Aktualny_kod
           Call Code
          Locate 2 , 8

          If Up_tankowanie = 0 Then
             Incr Code_2
             Call Buzzer
             If Code_2 > 9 Then Code_2 = 0
          End If

         Case 2:
           Call Aktualny_kod
           Call Code
          Locate 2 , 9

          If Up_tankowanie = 0 Then
             Incr Code_3
             Call Buzzer
             If Code_3 > 9 Then Code_3 = 0
          End If

         Case 3:
           Call Aktualny_kod
           Call Code
          Locate 2 , 10

          If Up_tankowanie = 0 Then
             Incr Code_4
             Call Buzzer
             If Code_4 > 9 Then Code_4 = 0
          End If

         Case 4:
          If Code_1 = Code_1_in And Code_2 = Code_2_in And Code_3 = Code_3_in And Code_4 = Code_4_in Then
             Locate 2 , 2
             Lcd "Kod prawidlowy"
             Call Locate_2_17
             Call Czekaj_2s
             Code_wybor = 5
             Set Kod
          Else
             Call Locate_2_3
             Lcd "Kod bledny"
             Call Locate_2_17
             Call Czekaj_2s
             Code_wybor = 0
             Reset Kod
          End If
         End Select
       Reset Zezw_wysw
    End If
End Sub

Sub Locate_2_17:
  Locate 2 , 17
End Sub
